#include <FastLED.h>  // (PIO #126)
#include "WS2812_Definitions.h"

#define LED_PIN     10
#define NUM_LEDS    8

#define DELAY 40

CRGB leds[NUM_LEDS];

void setup() {
  Serial.begin(9600);
  Serial.println(F("+------------------------------------+"));
  Serial.println(F("| Welcome to Arduino-neopixel-cycle  |"));
  Serial.println(F("+------------------------------------+"));

  FastLED.addLeds<WS2812, LED_PIN, GRB>(leds, NUM_LEDS);
    FastLED.setBrightness(24);

}

void loop() {
/* Blues
  scanRtoL( NAVY);
  scanLtoR( DARKBLUE);
  scanLtoR( MEDIUMBLUE);
  scanRtoL( BLUE);
  scanLtoR( DEEPSKYBLUE);
  scanRtoL( MIDNIGHTBLUE);
  scanLtoR( DODGERBLUE);
  scanRtoL( ROYALBLUE);
  scanLtoR( STEELBLUE);
  scanRtoL( DARKSLATEBLUE);
  scanLtoR( CORNFLOWERBLUE);
  scanRtoL( SLATEBLUE);
  scanLtoR( MEDIUMSLATEBLUE);
  scanRtoL( SKYBLUE);
  scanLtoR( LIGHTSKYBLUE);
  scanRtoL( LIGHTBLUE);
  scanLtoR( LIGHTSTEELBLUE);
  scanRtoL( POWDERBLUE);
  scanLtoR( ALICEBLUE);
  scanRtoL( BLACK);
*/

/* Greens
  scanRtoL( DARKGREEN);
  scanLtoR( GREEN);
  scanLtoR( MEDIUMSPRINGGREEN);
  scanRtoL( LIME);
  scanLtoR( SPRINGGREEN);
  scanRtoL( LIGHTSEAGREEN);
  scanLtoR( FORESTGREEN);
  scanRtoL( SEAGREEN);
  scanLtoR( LIMEGREEN);
  scanRtoL( MEDIUMSEAGREEN);
  scanLtoR( DARKOLIVEGREEN);
  scanRtoL( LAWNGREEN);
  scanLtoR( OLIVE);
  scanRtoL( DARKSEAGREEN);
  scanLtoR( LIGHTGREEN);
  scanRtoL( PALEGREEN);
  scanLtoR( YELLOWGREEN);
  scanRtoL( GREENYELLOW);
*/

  /* Reds */
    scanRtoL( DARKRED);
    scanLtoR( FIREBRICK);
    scanLtoR( MEDIUMVIOLETRED);
    scanRtoL( INDIANRED);
    scanLtoR( PALEVIOLETRED);
    scanRtoL( CRIMSON);
    scanLtoR( DARKSALMON);
    scanRtoL( SALMON);
    scanLtoR( RED);
    scanRtoL( FUCHSIA);
    scanLtoR( DEEPPINK);
    scanRtoL( ORANGERED);
    scanLtoR( TOMATO);
    scanRtoL( HOTPINK);
    scanLtoR( LIGHTPINK);
    scanRtoL( PINK);
    scanLtoR( MISTYROSE);
    scanRtoL( BLACK);

      /*
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        scanLtoR( XXXX);
        scanRtoL( XXXX);
        */
}

void scanLtoR(long COLOUR) {
for (int i = 0; i <= NUM_LEDS - 1; i++) {
    leds[i] = CRGB ( COLOUR);
    FastLED.show();
    delay(DELAY);
  }
}

void scanRtoL(long COLOUR) {
  for (int i = NUM_LEDS - 1; i >= 0; i--) {
    leds[i] = CRGB ( COLOUR);
    FastLED.show();
    delay(DELAY);
  }
}
